package scripts.roles;

import scripts.*;
import jinro.*;

// Role: 絶対者
// Camp: Civilians

class Absolute extends Civilian {
	def static order = 26;
	def static strings = Civilian.strings.attachBundle("roles/Absolute.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = true;	// All roles must define own "bite" property.
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	def static isInvisible() {
		return true;
	}
	def getPriority() {
		return 55;
	}
	Absolute(actor = null) {
		super(actor);
	}
	def getRoleName() {
		return strings.getString("absolute");
		//absolute=絶対者
	}
	// Calls when start argument/night time.
	def startPhase() {
		super.startPhase();
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				break;
			case 1:
				if(JinroGame.day == 0) {
					return;
				}
				break;
		}
	}
	
	def killed(state) {
		def actors = JinroGame.getActors();
		if(lovers == 0) {					//恋人以外
			if( (state != State.executed) && (state != State.shooting) && (state != State.loveguard) && (state != State.deathnote) ) {
				if(state == State.bitten) {		//噛みの場合（絶対者には無効）
					return;
				}
				if(this.state == State.live) {
					if( (deathnoteflg == false) || (state == State.followed) ) {//デスノで死んだら無残なを出さないが、道連れなら出す
						noticeKilled(strings.getString("notice.killed.normal", name) );
						//notice.killed.normal=%Sさんが無残な死体となって発見されました・・・。
					}
				}
			}
		} else {								//恋人の時
			def lover = actors.findAll { (it.lovers == this.lovers) && (it.name != name) };	//自分の相方の恋人
			def loversfellow = JinroGame.getProperty("loversfellow");
			if(state != State.executed) {
				if(state == State.bitten) {		//噛みの場合（絶対者には無効）
					if(lover.size() == 0) {
			//			lover[0].killed(State.followup);				//後追い
						this.killed(State.followup);
					}
					return;
				}
				if(state == State.bitten) {		//噛みの場合
					def wo = actors.findAll { it.isWolf() };
					wo.each {	//噛みを実行した狼を道連れ
						if( (it.state == State.live) && (loversfellow == true) ) {
							if(it.bitetarget2?.name == this.name) {
								it.killed(State.followed);		//道連れ
							} 
						}
					}
				}
				//吊り以外での恋人の後追い自殺
				switch(JinroGame.getProperty("ktime")) {
					case 0:	//投票後、猫の道連れで死んだ場合
						lover.each {
							if(it.state == State.live) {
								it.nextstate = State.followup;
								it.countdown = 2;
							}
						}
						break;
					case 1:	//明け方死んだ場合
						this.loverslive = false;						//無限ループ対策
						lover.each {
					//		JinroGame.addLog("aa name="+it.name+" state="+it.state);
							if((it.state == State.live) && (it.loverslive)) {
								it.killed(State.followup);				//後追い
							}
						}
						break;
				}
				if( (state != State.shooting) && (state != State.loveguard) && (state != State.deathnote) ) {
					if(this.state == State.live) {
						if( (deathnoteflg == false) || (state == State.followed) ) {//デスノで死んだら無残なを出さないが、道連れなら出す
							if(state == State.followup) {	//恋人後追いの時
								noticeKilled(strings.getString("notice.killed.lovers.followup", name) );
								//notice.killed.lovers.followup=%Sさんは恋人の後を追い自殺しました
							} else {
								noticeKilled(strings.getString("notice.killed.normal", name) );
								//notice.killed.normal=%Sさんが無残な死体となって発見されました・・・。
							}
						}
					}
				}
			} else {							//吊りの場合
				def lives = actors.findAll { it.isLive() && (it.name != name) && (it.voteforlovers == true) };
				if( lives && (loversfellow == true) )  {	//投票した人を道連れ
					def choice = lives[Math.floor(JinroGame.invokeMethod("rand") * lives.size()) as int];
					choice.nextstate = State.followed;
					choice.countdown = 2;
				}
				lover.each {	//恋人の後追い自殺
					if(it.state == State.live) {
						it.nextstate = State.followup;
						it.countdown = 2;
					}
				}
			}
		}
		this.killtime = JinroGame.getProperty("time0");
		this.state = state;
		JinroGame.addHistory(this);
	}
}
