package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Baker
// Camp: Civilians

class Baker extends Civilian {
	def static order = 28;
	def static strings = Civilian.strings.attachBundle("roles/Baker.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = false;	// All roles must define own "bite" property.
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	def getPriority() {
		return 34;
	}
	Baker(actor = null) {
		super(actor);
	}
	def getRoleName() {
		return strings.getString("Baker");
		//Baker=パン屋
	}
	// Calls when start argument/night time.
	def startPhase() {
		super.startPhase();
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				break;
			case 1:
				notice(strings.getString("notice.toasted"));
				//notice.toasted=焼くパンを「焼き＠パンの名前」の形式で夜時間の間に決定してください。
				break;
		}
	}
	// Returns the actor's command list
	//ツール本体から手動でコマンドを選択するために、そのリストを返します。
	def getCommands(actors) {
		def commands = super.getCommands(actors);
		if(!isLive()) {
			return commands;
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 1:
				if(statesave != State.live) return commands;
				if(!target) {
					commands << strings.getString("command.toasted") + "@" + strings.getString("command.toasted.bread0");
					commands << strings.getString("command.toasted") + "@" + strings.getString("command.toasted.bread1");
					commands << strings.getString("command.toasted") + "@" + strings.getString("command.toasted.bread2");
					commands << strings.getString("command.toasted") + "@" + strings.getString("command.toasted.bread3");
					commands << strings.getString("command.toasted") + "@" + strings.getString("command.toasted.bread4");
					commands << strings.getString("command.toasted") + "@" + strings.getString("command.toasted.bread5");
					//command.toasted=焼く
				}
				break;
		}
		return commands;
	}
	//コマンドを処理します。昼時間の投票の他、夜時間の護衛を処理します。
	def receiveMessage(type, target) {
		super.receiveMessage(type, target);
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				break;
			case 1:
				if(type != strings.getString("command.toasted")) {
					//command.toasted=焼く
					return;
				}
				if(this.target) {
					return;
				}
				this.target = target;
				breadname = target;
				notice(strings.getString("notice.toasted.target", target));
				//notice.toasted.target=焼き→%S
				break;
		}

	}
	// Checks if the game can go to next phase.
	//ゲームを進められるかどうかを返します。必要な能力の使用が済んだかどうかなどで判断します。
	def checkStep() {
		if(!super.checkStep()) {
			return false;
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				return true;
			case 1:
				if(target) {
					return true;
				}
				if(statesave != State.live) return true;
				break;
		}
		return false;
	}
}
