package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Civilian
// Camp: Civilians
// New role must have this class as an ancestor.

class Civilian {
	def static order = 0;		// All other roles must set larger value than this.	役職の順番を表します。
	def static strings = JinroLocalization.getBundle("roles/Civilian.properties");
	def static number = 0;		// All roles must define own "number" property.		この役職の人数を表します。
	def static bite = false;	// All roles must define own "bite" property.	この役職が初日犠牲者として死亡しないかどうかを表します。
	// Returns the proper number.
	//役職人数の初期値を返します。参加人数に応じて人数を自動で変動させるなどしますが、あくまでも初期値であるため人数はツール本体からいくらでも変更出来ます。
	def static getJustnumber(number) {
		return 0;
	}
	def static isInvisible() {
		return false;
	}
	def getPriority() {
		return 0;
	}
	// Update priority
	// Returns under 0: target -> it
	// Returns over 0 : it -> target
	def getUpdatePriority(target) {
		return 0;
	}
	def actor;
	def Civilian(actor = null) {
		this.actor = actor;
	}
	def getRoleName() {
		return strings.getString("civilian");
		//civilian=村人
	}
	def roleIs(role) {
		return getRoleName() == role.getRoleName();
	}
	def reset() {
		target = null;
		target2 = null;
		breadname = null;
		bitetarget2 = null;
		defended = false;
		divined = false;
		loveguard = false;
		deviltrigger = false;
		DNtarget = null;
		DNsealtarget = false;
		deathnoteflg = false;
		DTtarget = null;
		DTsealtarget = false;
		sealtarget = false;
		baka = false;
		shooting = false;
		loveguarddead = false;
		voteforlovers = false;
		norevival = false;
		revivalsuccess = false;
		revivaltarget = null;
		voted = false;		//投票済フラグ
	}
	//コマンドを処理します。村人の場合は昼時間に投票を処理するのみです。
	def receiveMessage(type, target) {
	//	notice("aaa type="+type+" target="+target);
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				if(type != strings.getString("command.vote")) {
				//command.vote=投票
					return;
				}
				if(this.target) { return; }
				if(target?.name != name && target?.isLive()) {
					this.target = target;
					notice(strings.getString("notice.vote.target", target.name));
					//notice.vote.target=投票先→%Sさん
					voted = true;
				}
				break;
			case 1:
				if(JinroGame.day != 0) {		//二日目以降（デビルトリガー用）
					if( (deviltrigger == true) && (!this.DTtarget) && (this.DTsealtarget == false) ) {
						if(type == strings.getString("command.dt")) {
							//command.dt=射撃
							if(target?.name != name) {
								if( target?.isLive() ) {
									this.DTtarget = target;
									notice(strings.getString("notice.dt.target", target.name));
									//notice.dt.target=射撃先→%Sさん
								}
							}
						}
						if(type == strings.getString("command.sealdt")) {
							//command.sealdt=撃たない
					//		if(target?.name != name) {
					//			if( target?.first == true) {	//ターゲットは誰でもOKに
									this.DTsealtarget = true;
								//	notice(strings.getString("notice.seal.target", target.name));
									//notice.seal.target=撃たない→%Sさん
									notice(strings.getString("notice.seal"));
									//notice.seal=撃たない→
									notice(strings.getString("notice.seal.target." + (Math.floor(JinroGame.invokeMethod("rand") * 4) as int) ));
									//notice.seal.target.0=今宵、あなたは呪われし長銃『デビルトリガー』を封印した。
									//notice.seal.target.1=呪われし長銃『デビルトリガー』は鈍く重い光を放っている。
									//notice.seal.target.2=呪われし長銃『デビルトリガー』はカタカタと物欲しそうに音を立てた。
					//			}
					//		}
						}
					}
					if( (deathnote == true) && (!this.DNtarget) && (this.DNsealtarget == false) ) {
						if(type == strings.getString("command.deathnote")) {
							//command.deathnote=死神手帳
							if(target?.name != name) {
								if( target?.isLive() ) {
									if(!isWolf() || !target.isWolf()) {
										this.DNtarget = target;
										notice(strings.getString("notice.deathnote.target", target.name));
										//notice.deathnote.target=死神手帳→%Sさん
										
										def actors = JinroGame.getActors();
										def lives2 = actors.findAll { it.isLive() && (it.name != DNtarget.name) };
										JinroGame.setProperty("deathnotenext", lives2.get(Math.floor(JinroGame.invokeMethod("rand") * lives2.size()) as int) );
									}
								}
							}
						}
						if(type == strings.getString("command.sealdeathnote")) {
							//command.sealdeathnote=死神手帳に書かない
							this.DNsealtarget = true;
						//	notice(strings.getString("notice.sealdeathnote.target", target.name));
							//notice.sealdeathnote.target=死神手帳に書かない→%Sさん
							notice(strings.getString("notice.sealdeathnote"));
							//notice.sealdeathnote=死神手帳に書かない→
						}
					}
				}
				break;
			case 7:		//希望役職
				if(type != strings.getString("command.hope")) {
				//command.hope=希望
					return;
				}
				if(this.target) { return; }
				if(this.hoperolename != null) { return; }
				def listroles = JinroGame.getProperty("listroles");
				listroles.findAll{ (it.setnum > 0) && (it.name == target) }.each {
					this.hoperolename = target;
			//		this.target = target;
				}
				for(int i=1; i<=3; i++) {
					if(target == strings.getString("command.nohope"+i)) {
					//command.nohope1=無し
						this.hoperolename = strings.getString("command.nohope1");
			//		this.target = target;
					}
				}
				if(this.hoperolename != null) {
					notice(strings.getString("notice.hope.target", this.hoperolename));
					//notice.hope.target=希望→%Sさん
				}
				
				def yethope = JinroGame.getActors().findAll{ it.isLive() &&  it.hoperolename == null };
				if(yethope.size() == 0) {
					JinroGame.addLog( strings.getString("com.hope") );
					//com.hope=希望が全て来ました(｀・ω・´)
				}
				
				break;
		}
	}
	// Calls when start argument/night time.
	def startPhase() {
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
		/*		if(deathnote == true) {
					notice(strings.getString("notice.deathnote"));
					//notice.deathnote=あなたの手に死神手帳が存在しています。
				}*/
				break;
			case 1:
				def actors = JinroGame.getActors();
				def first = actors.findAll { (it.first == true) };
			//	def GM = "初日犠牲者"
			//	if(first) {
			//		GM = first[0].name;
			//	}
				if(deviltrigger == true) {
					notice(strings.getString("notice.dt"));
					//notice.dt=あなたの手に呪われし長銃『デビルトリガー』が存在しています。
					if(JinroGame.day == 0) {
						notice(strings.getString("notice.dt1"));
						//notice.dt1=明日の夜以降に撃つ事が出来ます。
						return;
					}
					notice(strings.getString("notice.dt2"));
					//notice.dt2=射撃先を「射撃＠対象の名前」の形式で夜時間の間に決定してください。
					notice(strings.getString("notice.dt3"));
					//notice.dt3=但し、撃たない事を選択する事も出来ます。
					notice(strings.getString("notice.dt4"));
					//notice.dt4=撃たない場合は「撃たない＠」として下さい。
				}
				if( (deathnote == true) && (JinroGame.day > 0) ) {
					notice(strings.getString("notice.deathnote"));
					//notice.deathnote=あなたの手に死神手帳が存在しています。
					notice(strings.getString("notice.deathnote2"));
					//notice.deathnote2=死神手帳を使用する場合には「死神手帳＠対象の名前」の形式で夜時間の間に決定して下さい。
					notice(strings.getString("notice.deathnote3"));
					//notice.deathnote3=但し、死神手帳を使用しない事を選択する事も出来ます。
					notice(strings.getString("notice.deathnote4"));
					//notice.deathnote4=死神手帳を使用しない場合は「死神手帳を使用しない＠」として下さい。
				}
				break;
		}
	}
	
	
	def endPhase() {
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				if(deathnote == true) {
					notice(strings.getString("notice.deathnote"));
					//notice.deathnote=あなたの手に死神手帳が存在しています。
				}
				break;
			case 1:
				break;
		}
	}
	
	
	// Returns the actor's command list
	//ツール本体から手動でコマンドを選択するために、そのリストを返します。
	def getCommands(actors) {
		def commands = [];
		if(!isLive()) {
			return commands;
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				if(JinroGame.getProperty("voteflg") == false) {
					break;
				}
				if(!target) {
					actors.findAll{ it.name != name && it.isLive() }.each {
						commands << strings.getString("command.vote") + "@" + it.name;
					//command.vote=投票
					}
				}
				break;
			case 1:
				if( (deviltrigger == true) && (JinroGame.day > 0) ) {
					if( (!this.DTtarget) && (this.DTsealtarget == false) ){
						actors.findAll{ (it.name != name) && (it.isLive()) }.each {
							commands << strings.getString("command.dt") + "@" + it.name;
							//command.dt=射撃
						}
					//	actors.findAll{ (it.name != name) && (it.first == true) }.each {
							commands << strings.getString("command.sealdt") + "@";
							//command.sealdt=撃たない
					//	}
					}
				}
				if( (deathnote == true) && (JinroGame.day > 0) ) {
					if( (!this.DNtarget) && (this.DNsealtarget == false) ){
						//command.deathnote=死神手帳
						if(isWolf()) {
							actors.findAll{ (it.name != name) && (it.isLive()) && (!it.isWolf()) }.each {
								commands << strings.getString("command.deathnote") + "@" + it.name;
							}
						} else {
							actors.findAll{ (it.name != name) && (it.isLive()) }.each {
								commands << strings.getString("command.deathnote") + "@" + it.name;
							}
						}
					//	actors.findAll{ (it.name != name) && (it.first == true) }.each {
							commands << strings.getString("command.sealdeathnote") + "@";
							//command.sealdeathnote=死神手帳を使用しない
					//	}
					}
				}
				break;
			case 7:	//希望役職
				if(this.hoperolename == null) {
					def listroles = JinroGame.getProperty("listroles");
					listroles.findAll{ it.setnum > 0 }.each {
						commands << (strings.getString("command.hope") + "@" + it.name);
						//command.hope=希望
					}
					commands << (strings.getString("command.hope") + "@" + strings.getString("command.nohope1"));
				}
				break;

		}
		return commands;
	}
	// Checks if the game can go to next phase.
	//時間を進めることが出来るならtrue、出来ない場合はfalse。
	def checkStep() {
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				if(target) {
					return true;
				}
				break;
			case 1:
				if(JinroGame.day != 0) {
					def res = false;
					
					if( (deviltrigger == true) && (deathnote == true) ) {	//デビトリとデスノ同時持ち
						if( (this.DTtarget) || (this.DTsealtarget == true) ) {
							if( (this.DNtarget) || (this.DNsealtarget == true) ) { res = true; }
						}
					}
					if(deviltrigger == true) {
						if( (this.DTtarget) || (this.DTsealtarget == true) ) { res = true; }
					}
					if(deathnote == true) {
						if( (this.DNtarget) || (this.DNsealtarget == true) ) { res = true; }
					}
					if( (deviltrigger == false) && (deathnote == false) ) { res = true; }
					return res;
				}
				return true;
				break;
			case 7:
				if(this.hoperolename != null) {
					return true;
				}
				break;
		}
		return false;
	}
	// Goes to next phase.
	def update() {
		if(countdown > 0) {
			countdown--;
			if(countdown == 0) {
				killed(nextstate);
			}
		}
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				if(baka == true) {
					noticeKilled(strings.getString("notice.baka", name));
					//notice.baka=%SさんＭＩＳＳ！ ﾊﾞｶｰヾ(ﾟдﾟ)ﾉ゛
				}
				if(shooting == true) {
					noticeKilled(strings.getString("notice.killed.shooting", name));
					//notice.killed.shooting=%Sさんは昨夜何者かによって射殺された・・・。
					killed(State.shooting);
				}
				if(loveguarddead == true) {
					noticeKilled(strings.getString("notice.killed.loveguard", name));
					//notice.killed.loveguard=%Sさんは昨夜何者かによって射殺された・・・。【ラブガード】
					killed(State.loveguard);
				}
				if(deathnoteflg == true) {
					noticeKilled(strings.getString("notice.killed.deathnote", name));
					//notice.killed.deathnote=%Sさんは死体で発見されました。
					killed(State.deathnote);
				}
				break;
		}
	}
	// Checks if the actor is living.
	//生存しているかどうかを返します。現在の状態の優先度が51未満である場合死亡として扱われます。
	def isLive() {
		return state.priority > 50;
	}
	// When the actor is killed.
	//状態を変化させ、それに伴う処理を行います。死亡時は死者のリストに追加し、処刑以外の死因であれば通知するようにします。
	//吊りの場合はgame.groovyのexecutionでメッセージを出しているのでここでは出さない
	//射殺やラブガードではupdateでメッセージを出してるのでここでは出さない
	def killed(state) {
		def actors = JinroGame.getActors();
		if(lovers == 0) {					//恋人以外
			if( (state != State.executed) && (state != State.shooting) && (state != State.loveguard) && (state != State.deathnote) ) {
				if(this.state == State.live) {
					if( (deathnoteflg == false) || (state == State.followed) ) {//デスノで死んだら無残なを出さないが、道連れなら出す
						noticeKilled(strings.getString("notice.killed.normal", name) );
						//notice.killed.normal=%Sさんが無残な死体となって発見されました・・・。
					}
				}
			}
		} else {								//恋人の時
			def lover = actors.findAll { ((it.lovers & this.lovers) != 0) && (it.name != name) };	//自分の相方の恋人
			def loversfellow = JinroGame.getProperty("loversfellow");
			if(state != State.executed) {
				if(state == State.bitten) {		//噛みの場合
					def wo = actors.findAll { it.isWolf() };
					wo.each {	//噛みを実行した狼を道連れ
						if( (it.state == State.live) && (loversfellow == true) ) {
							if(it.bitetarget2?.name == this.name) {
								it.killed(State.followed);		//道連れ
							} 
						}
					}
				}
				//吊り以外での恋人の後追い自殺
				switch(JinroGame.getProperty("ktime")) {
					case 0:	//投票後、猫の道連れで死んだ場合
						lover.each {
							if(it.state == State.live) {
								it.nextstate = State.followup;
								it.countdown = 2;
							}
						}
						break;
					case 1:	//明け方死んだ場合
						this.loverslive = false;						//無限ループ対策
						lover.each {
					//		JinroGame.addLog("aa name="+it.name+" state="+it.state);
							if((it.state == State.live) && (it.loverslive)) {
								it.killed(State.followup);				//後追い
							}
						}
						break;
				}
				if( (state != State.shooting) && (state != State.loveguard) && (state != State.deathnote) ) {
					if(this.state == State.live) {
						if( (deathnoteflg == false) || (state == State.followed) ) {//デスノで死んだら無残なを出さないが、道連れなら出す
							if(state == State.followup) {	//恋人後追いの時
								noticeKilled(strings.getString("notice.killed.lovers.followup", name) );
								//notice.killed.lovers.followup=%Sさんは恋人の後を追い自殺しました
							} else {
								noticeKilled(strings.getString("notice.killed.normal", name) );
								//notice.killed.normal=%Sさんが無残な死体となって発見されました・・・。
							}
						}
					}
				}
			} else {							//吊りの場合
				def lives = actors.findAll { it.isLive() && (it.name != name) && (it.voteforlovers == true) };
				if( lives && (loversfellow == true) )  {	//投票した人を道連れ
					def choice = lives[Math.floor(JinroGame.invokeMethod("rand") * lives.size()) as int];
					choice.nextstate = State.followed;
					choice.countdown = 2;
				}
				lover.each {	//恋人の後追い自殺
					if(it.state == State.live) {
						it.nextstate = State.followup;
						it.countdown = 2;
					}
				}
			}
		}
		this.killtime = JinroGame.getProperty("time0");
		this.state = state;
		JinroGame.addHistory(this);
	}
	//死亡メッセージを通知するまでプールしておきます。これは通知順から死因が判らなくなるようにするための処置です。
	def noticeKilled(message) {
		JinroGame.invokeMethod("noticeKilled", message);	//game.groovyのnoticeKilledを呼び出す
	}
	// If it returns true, the role count as a wolf.
	def isWolf() {
		return false;
	}
	// If it returns true, the role count as a civilian.
	def isCivilian() {
		return true;
	}
	// Notifies the actor of the role.
	//参加者に対し役職の通知を行います。
	def noticeRole() {
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 1:
			case 3:
				def name = JinroGame.getAlias(getRoleName());
				notice(strings.getString("notice.role", name));
				break;
		}
	}
	// Judges victory or defeat.
	// if the result is... 0: civilians win, 1: wolves win, 2: foxes win
	//勝利結果 0=村 1=狼 2=狐 3=恋人 4=狐＋恋人 return true=勝利 false=敗北
	def judge(result) {
		if(lovers != 0) {
			def lover = JinroGame.getActors().findAll { ((it.lovers & this.lovers) != 0) && it.isLive() };
			def lovercount = [];
			def lovermax = 0;
			lover.each {
				if(lovercount[it.lovers] == null) lovercount[it.lovers] = 1;
				lovercount[it.lovers]++;
				if(lovercount[it.lovers] > lovermax) {
					lovermax = lovercount[it.lovers];
				}
			}
			if(lovermax >= 2) {
				return (result == 3) || (result == 4);	//恋人
			} else {
				return false;
			}
		}
		return result == 0;							//村
	}
	// Notifies the actor of the message.
	//参加者にメッセージを通知し、それをツール本体のログに追加します。
	def notice(message) {
		noticelog << message;
		if(skypeid) {
			JinroSkype.notice(skypeid, message);
		}
		JinroGame.addLog(strings.getString("notice.log", name, message));
	}
	// Copy the latest notified message into clipboard.
	def copynoticelog() {
		if(noticelog) {
			JinroInterface.copyClipboard(noticelog[-1]);
		}
	}
	def propertyMissing(String name) {
		return actor.getAt(name);
	}
	def propertyMissing(String name, value) {
		actor.putAt(name, value);
	}
}
