package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Cupid
// Camp: Civilians

class Cupid extends Civilian {
	def static order = 22;
	def static strings = Civilian.strings.attachBundle("roles/Cupid.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = true;	// All roles must define own "bite" property.	//この役職が初日犠牲者として死亡しないかどうかを表します。
	def static isInvisible() {
		return true;
	}
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	def getPriority() {
		return 41;
	}
	Cupid(actor = null) {
		super(actor);
	}
	def getRoleName() {
//		return "キューピット";
		return strings.getString("qp");
	}
	// Calls when start argument/night time.
	def startPhase() {
		super.startPhase();
	}
	
	// Returns the actor's command list
	def getCommands(actors) {
		def commands = super.getCommands(actors);
		if(!isLive()) {
			return commands;
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 3:
				if(JinroGame.day == 0) {
					if(!target) {
						actors.findAll{ (it.name != name) && (it.isLive()) }.each {
							if( ((it.lovers == 0) && (it.keep == 0)) || JinroGame.getProperty("yagamo") ) {
								commands << strings.getString("command.cupid") + "@" + it.name;
								//command.cupid=恋人
							}
						}
					}
				}
				break;
		}
		return commands;
	}
	//コマンドを処理します。
	def receiveMessage(type, target) {
		super.receiveMessage(type, target);
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				break;
			case 3:
				if(JinroGame.day == 0) {	//初日
					if(this.target) { return; }
					if(type == strings.getString("command.cupid")) {
					//command.cupid=恋人
						if(target?.name != name && target?.isLive()) {
							if( ((target.lovers == 0) && (target.keep == 0))
								 || JinroGame.getProperty("yagamo") )	//targetがまだ恋人でない
							{
								target.lovers |= this.cupid;
								notice(strings.getString("notice.cupid.target", target.name));
								//notice.cupid.target=恋人→%Sさん
								
								def actors = JinroGame.getActors();
								def sellovers = actors.findAll { ((it.lovers & this.cupid) != 0) };
								if(sellovers.size() >= 2) {
									notice(strings.getString("notice.cupid1", sellovers[0].name, sellovers[1].name ));
									//notice.cupid1=あなたが放った愛の矢は %Sさんと %Sさんに命中しました
									this.target = target;
									
									//恋人１にメッセージ
									def mes0 = strings.getString("notice.lovers.partner", sellovers[1].name )
									//notice.lovers.partner=愛の矢があなたに命中しました。あなたの恋人は%Sさんです。
									if(sellovers[0].skypeid) {
										JinroSkype.notice(sellovers[0].skypeid, mes0);
									}
									noticelog << mes0;
									JinroGame.addLog(strings.getString("notice.log", sellovers[0].name, mes0));
									
									//恋人２にメッセージ
									def mes1 = strings.getString("notice.lovers.partner", sellovers[0].name )
									//notice.lovers.partner=愛の矢があなたに命中しました。あなたの恋人は%Sさんです。
									if(sellovers[1].skypeid) {
										JinroSkype.notice(sellovers[1].skypeid, mes1);
									}
									noticelog << mes1;
									JinroGame.addLog(strings.getString("notice.log", sellovers[1].name, mes1));
									//恋人チャット作成
									def skypeids = [];
									sellovers.each {
										if(it.skypeid) {
											skypeids << it.skypeid;
										}
									}
									if(skypeids.size() >= 2) {
										JinroSkype.notice(skypeids as String[], 
											strings.getString("chat.created", strings.getString("command.cupid") ));
										//chat.created=%Sチャットです。チャット捕捉のために何か言葉を打ち込んでください。
										//command.cupid=恋人
									}
								}
							} else {		//targetが既に恋人
								notice(strings.getString("notice.cupid2", target?.name ));
								//notice.cupid2=%Sさんには既に愛の矢が刺さっています。
							}
						}
					}
					return;
				}
				break;
		}

	}
	// Checks if the game can go to next phase.
	//ゲームを進められるかどうかを返します。必要な能力の使用が済んだかどうかなどで判断します。
	def checkStep() {
	//	if(!super.checkStep()) {
	//		return false;
	//	}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
			case 1:
				if(!super.checkStep()) {
					return false;
				}
				return true;
				break;
			case 3:
				if(JinroGame.day == 0) {
					if(target) {
						return true;
					}
					return false;
				}
				return true;
				break;
		}
		return false;
	}
	// Notifies the actor of the role.
	//参加者に対し役職の通知を行います。
	def noticeRole() {
		def name = JinroGame.getAlias(getRoleName());
		notice(strings.getString("notice.role", name));
		notice(strings.getString("notice.cupid"));
		//notice.cupid=「恋人＠対象の名前」の形式で２回実行し、恋人二人を決定してください。
	}
	// Judges victory or defeat.
	// if the result is... 0: civilians win, 1: wolves win, 2: foxes win
	//勝利結果 0=村 1=狼 2=狐 3=恋人 4=狐＋恋人 return true=勝利 false=敗北
	def judge(result) {
		if(lovers == 0) {	//キューピットが恋人でない時
			def lover = JinroGame.getActors().findAll { ((it.lovers & this.cupid) != 0) && it.isLive() };
			if(lover.size() >= 2) {
				return (result == 3) || (result == 4);	//恋人
			} else {
				return false;
			}
		} else {			//キューピットが恋人の時
			def lover = JinroGame.getActors().findAll { ((it.lovers & this.lovers) != 0) && it.isLive() };
			def lovercount = [];
			def lovermax = 0;
			lover.each {
				if(lovercount[it.lovers] == null) lovercount[it.lovers] = 1;
				lovercount[it.lovers]++;
				if(lovercount[it.lovers] > lovermax) {
					lovermax = lovercount[it.lovers];
				}
			}
			if(lovermax >= 2) {
				return (result == 3) || (result == 4);	//恋人
			} else {
				return false;
			}
		}
		return false;
	}
}
