package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Lunatic
// Camp: Wolves

class Fanatic extends Civilian {
	def static order = 16;
	def static strings = Civilian.strings.attachBundle("roles/Fanatic.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = false;	// All roles must define own "bite" property.
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	Fanatic(actor = null) {
		super(actor);
	}
	def getPriority() {
		return 89;
	}
	def getRoleName() {
		return strings.getString("fanatic");
		//fanatic=狂信者
	}
	//参加者に対し役職の通知を行います。
	def noticeRole() {
		super.noticeRole();
		def actors = JinroGame.getActors();
		actors.findAll{ it.name != name && it.isWolf() }.each {
			notice(strings.getString("notice.wolf.partner", it.name, JinroGame.getAlias( it.getRoleName() )));
			//notice.wolf.partner=%1$Sさんが%2$Sです。
		}
	}
	// Judges victory or defeat.
	// if the result is... 0: civilians win, 1: wolves win, 2: foxes win
	//勝利結果 0=村 1=狼 2=狐 3=恋人 4=狐＋恋人 return true=勝利 false=敗北
	def judge(result) {
		if(lovers != 0) {
			def lover = JinroGame.getActors().findAll { ((it.lovers & this.lovers) != 0) && it.isLive() };
			def lovercount = [];
			def lovermax = 0;
			lover.each {
				if(lovercount[it.lovers] == null) lovercount[it.lovers] = 1;
				lovercount[it.lovers]++;
				if(lovercount[it.lovers] > lovermax) {
					lovermax = lovercount[it.lovers];
				}
			}
			if(lovermax >= 2) {
				return (result == 3) || (result == 4);	//恋人
			} else {
				return false;
			}
		}
		return result == 1;			//狼陣営
	}
}
