package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Fox
// Camp: Foxes

class Fox extends Civilian {
	def static order = 7;	//役職の順番を表します。 これはツール本体の「ゲームを開始する」ダイアログで使用されます。 全ての役職クラスはこのプロパティを自身で定義する必要があり、 またその値はCivilian.orderよりも大きいものにしなくてはいけません。
	def static strings = Civilian.strings.attachBundle("roles/Fox.properties");
	def static number = 0;	// All roles must define own "number" property.	この役職の人数を表します。
	def static bite = true;	// All roles must define own "bite" property.	この役職が初日犠牲者として死亡しないかどうかを表します。
	def static isInvisible() {
		return true;
	}
	// Returns the proper number.
	def static getJustnumber(number) {
		if(number > 14) {
			return 1;
		} else {
			return 0;
		}
	}
	Fox(actor = null) {
		super(actor);
	}
	def getPriority() {
		return 65;
	}
	// If it returns true, the role count as a civilian.
	def isCivilian() {
		return false;
	}
	def getRoleName() {
		return strings.getString("fox");
		//fox=妖狐
	}
	// Goes to next phase.
	def update() {
		if(divined) {				//占われているか？
			killed(State.cursed);	//呪殺
			divined = false;
		}
		super.update();
	}
	// When the actor is killed.
	//状態を変化させ、それに伴う処理を行います。死亡時は死者のリストに追加し、処刑以外の死因であれば通知するようにします。 また、妖狐は噛みによって死亡しません。
	def killed(state) {
		def actors = JinroGame.getActors();
		if(lovers == 0) {						//恋人以外
			if( (state != State.executed) && (state != State.shooting) && (state != State.loveguard) && (state != State.deathnote) ) {
				if(state == State.bitten) {		//噛みの場合（妖狐には無効）
					return;
				}
				if(this.state == State.live) {
					if( (deathnoteflg == false) || (state == State.followed) ) {//デスノで死んだら無残なを出さないが、道連れなら出す
						noticeKilled(strings.getString("notice.killed.normal", name) );
						//notice.killed.normal=%Sさんが無残な死体となって発見されました・・・。
					}
				}
			}
		} else {								//恋人の時
			def lover = actors.findAll { (it.lovers == this.lovers) && (it.name != name) && it.isLive() };
			def loversfellow = JinroGame.getProperty("loversfellow");
			if(state != State.executed) {
				if(state == State.bitten) {		//噛みの場合（妖狐には無効）
					if(lover.size() == 0) {
			//			lover[0].killed(State.followup);				//後追い
						this.killed(State.followup);
					}
					return;
				}
				//呪殺を出した占い師を道連れ
				if(loversfellow == true) {
					def fo = actors.findAll { it.roleIs(new Fortuneteller()) || it.roleIs(new Wolffortune()) };
					fo.each {
						if(  (it.state == State.live) ) {
							if(it.target?.name == this.name) {
								it.killed(State.followed);
							}
						}
					}
				}
				//吊り以外での恋人の後追い自殺
				switch(JinroGame.getProperty("ktime")) {
					case 0:	//投票後、猫の道連れで死んだ場合
						lover.each {
							if(it.state == State.live) {
								it.nextstate = State.followup;
								it.countdown = 2;
							}
						}
						break;
					case 1:	//明け方死んだ場合
						this.loverslive = false;						//無限ループ対策
						lover.each {
					//		JinroGame.addLog("aa name="+it.name+" state="+it.state);
							if((it.state == State.live) && (it.loverslive)) {
								it.killed(State.followup);				//後追い
							}
						}
						break;
				}
				if( (state != State.shooting) && (state != State.loveguard) && (state != State.deathnote) ) {
					if(this.state == State.live) {
						if( (deathnoteflg == false) || (state == State.followed) ) {//デスノで死んだら無残なを出さないが、道連れなら出す
							if(state == State.followup) {	//恋人後追いの時
								noticeKilled(strings.getString("notice.killed.lovers.followup", name) );
								//notice.killed.lovers.followup=%Sさんは恋人の後を追い自殺しました
							} else {
								noticeKilled(strings.getString("notice.killed.normal", name) );
								//notice.killed.normal=%Sさんが無残な死体となって発見されました・・・。
							}
						}
					}
				}
			} else {							//吊りの場合
				def lives = actors.findAll { it.isLive() && (it.name != name) && (it.voteforlovers == true) };
				if( lives && (loversfellow == true) )  {	//投票した人を道連れ
					def choice = lives[Math.floor(JinroGame.invokeMethod("rand") * lives.size()) as int];
					choice.nextstate = State.followed;
					choice.countdown = 2;
				}
				lover.each {	//恋人の後追い自殺
					if(it.state == State.live) {
						it.nextstate = State.followup;
						it.countdown = 2;
					}
				}
			}
		}
		this.killtime = JinroGame.getProperty("time0");
		this.state = state;
		JinroGame.addHistory(this);
	}


	//参加者に対し役職の通知を行います。
	def noticeRole() {
		super.noticeRole();
		def foxchat = JinroGame.getProperty("foxchat");
		if(foxchat == true) {
	//		if( !this.roleIs(new Minifox()) ) {
				def actors = JinroGame.getActors();
				actors.findAll{ it.name != name && ( it.roleIs(new Fox()) || it.roleIs(new Foxnine()) ) }.each {
					notice(strings.getString("notice.fox", it.name, JinroGame.getAlias(it.getRoleName())));
					//notice.fox=%1$Sさんが%2$Sです。
				}
	//		}
		}
	}
	// Judges victory or defeat.
	// if the result is... 0: civilians win, 1: wolves win, 2: foxes win
	//勝利結果 0=村 1=狼 2=狐 3=恋人 4=狐＋恋人 return true=勝利 false=敗北
	def judge(result) {
		if(lovers != 0) {
			def lover = JinroGame.getActors().findAll { ((it.lovers & this.lovers) != 0) && it.isLive() };
			def lovercount = [];
			def lovermax = 0;
			lover.each {
				if(lovercount[it.lovers] == null) lovercount[it.lovers] = 1;
				lovercount[it.lovers]++;
				if(lovercount[it.lovers] > lovermax) {
					lovermax = lovercount[it.lovers];
				}
			}
			if(lovermax >= 2) {
				return (result == 3) || (result == 4);	//恋人
			} else {
				return false;
			}
		}
		return (result == 2) || (result == 4);		//狐の場合
	}
}
