package scripts.roles;

import scripts.*;
import jinro.*;

// Role: 九尾
// Camp: Foxes

class Foxnine extends Fox {
	def static order = 21;	//役職の順番を表します。 これはツール本体の「ゲームを開始する」ダイアログで使用されます。 全ての役職クラスはこのプロパティを自身で定義する必要があり、 またその値はCivilian.orderよりも大きいものにしなくてはいけません。
	def static strings = Fox.strings.attachBundle("roles/Foxnine.properties");
	def static number = 0;	// All roles must define own "number" property.	この役職の人数を表します。
	def static bite = true;	// All roles must define own "bite" property.	この役職が初日犠牲者として死亡しないかどうかを表します。
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	Foxnine(actor = null) {
		super(actor);
	}
	def getPriority() {
		return 66;
	}
	def getRoleName() {
		return strings.getString("foxnine");
		//foxnine=九尾
	}
	// Calls when start argument/night time.
	def startPhase() {
		super.startPhase()
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				break;
			case 1:
				if(JinroGame.day == 0) { break; }
				notice(strings.getString("notice.pray"));
				//notice.pray=念殺先を「念殺＠対象の名前」の形式で夜時間の間に決定してください。
				notice(strings.getString("notice.pray2"));
				//notice.pray2=但し、念殺しない事を選択する事も出来ます。
				def actors = JinroGame.getActors();
				def first = actors.findAll { (it.first == true) };
				def GM = "初日犠牲者"
				if(first) {
					GM = first[0].name;
				}
				notice(strings.getString("notice.pray3",GM));
				//notice.pray3=念殺をしない場合は「念殺しない＠%S」として下さい。
				
				break;
		}
	}
	// Returns the actor's command list
	def getCommands(actors) {
		def commands = super.getCommands(actors);
		if(!isLive()) {
			return commands;
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 1:
				if(JinroGame.day == 0) { break; }
				if(target) { break; }
				if(this.sealtarget == true)  { break; }
				if(statesave != State.live) return commands;
				actors.findAll{ it.name != name && it.isLive() }.each {
					commands << strings.getString("command.pray") + "@" + it.name;
					//command.pray=念殺
				}
				actors.findAll{ (it.name != name) && (it.first == true) }.each {
					commands << strings.getString("command.pray2") + "@" + it.name;
					//command.pray2=念殺しない
				}
				break;
		}
		return commands;
	}
	def receiveMessage(type, target) {
		super.receiveMessage(type, target)
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				break;
			case 1:
				if(JinroGame.day == 0) { return; }
				if(this.target) { return; }
				if(this.sealtarget == true)  { return; }
				if(type == strings.getString("command.pray")) {
					//command.pray=念殺
					if(target?.name != name && target?.isLive()) {
						this.target = target;
						notice(strings.getString("notice.pray.target", target.name));
						//notice.pray.target=念殺先→%Sさん
					}
				}
				if(type == strings.getString("command.pray2")) {
					//command.pray2=念殺しない
					this.sealtarget = true;
					notice(strings.getString("notice.pray2.target", target.name));
					//notice.pray2.target=念殺しない→%Sさん
				}
				break;
		}
	}
	// Checks if the game can go to next phase.
	def checkStep() {
		if(!super.checkStep()) {
			return false;
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				return true;
			case 1:
				if(JinroGame.day == 0) { return true; }
				if(target) { return true; }
				if(this.sealtarget == true)  { return true; }
				if(statesave != State.live) return true;
				break;
		}
		return false;
	}
	// Goes to next phase.
	def update() {
		super.update();
		if(divined) {				//占われているか？
			killed(State.cursed);	//呪殺
			divined = false;
		}
	}
}
