package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Lunatic
// Camp: Wolves

class Lunatic extends Civilian {
	def static order = 4;
	def static strings = Civilian.strings.attachBundle("roles/Lunatic.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = false;	// All roles must define own "bite" property.
	// Returns the proper number.
	def static getJustnumber(number) {
		if(number > 9) {
			return 1;
		} else {
			return 0;
		}
	}
	Lunatic(actor = null) {
		super(actor);
	}
	def getPriority() {
		return 90;
	}
	def getRoleName() {
		return strings.getString("lunatic");
		//lunatic=狂人
	}
	// Judges victory or defeat.
	// if the result is... 0: civilians win, 1: wolves win, 2: foxes win
	//勝利結果 0=村 1=狼 2=狐 3=恋人 4=狐＋恋人 return true=勝利 false=敗北
	def judge(result) {
		if(lovers != 0) {
			def lover = JinroGame.getActors().findAll { ((it.lovers & this.lovers) != 0) && it.isLive() };
			def lovercount = [];
			def lovermax = 0;
			lover.each {
				if(lovercount[it.lovers] == null) lovercount[it.lovers] = 1;
				lovercount[it.lovers]++;
				if(lovercount[it.lovers] > lovermax) {
					lovermax = lovercount[it.lovers];
				}
			}
			if(lovermax >= 2) {
				return (result == 3) || (result == 4);	//恋人
			} else {
				return false;
			}
		}
		return result == 1;			//狼陣営
	}
}
