package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Medium
// Camp: Civilians

class Medium extends Civilian {
	def static order = 3;
	def static strings = Civilian.strings.attachBundle("roles/Medium.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = false;	// All roles must define own "bite" property.
	// Returns the proper number.
	def static getJustnumber(number) {
		if(number > 8) {
			return 1;
		} else {
			return 0;
		}
	}
	def getPriority() {
		return 45;
	}
	Medium(actor = null) {
		super(actor);
	}
	def getRoleName() {
		return strings.getString("medium");
		//medium=霊能者
	}
	// Calls when start argument/night time.
	def startPhase() {
		super.startPhase();
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				break;
			case 1:
				if(JinroGame.day == 0) {
					return;
				}
				medium();
				break;
		}
	}
	def medium() {
		
		def execactor = JinroGame.getProperty("execactor");
		if(execactor.roleIs(new Wolfhead())) {
			notice(strings.getString("notice.medium.result", execactor.name, JinroGame.getAlias(new Wolfhead().getRoleName())));
		} else if(execactor.isWolf()) {
			notice(strings.getString("notice.medium.result", execactor.name, strings.getString("notice.medium.result.black")));
		} else if(execactor.roleIs(new Minifox())) {
			notice(strings.getString("notice.medium.result", execactor.name, JinroGame.getAlias(new Minifox().getRoleName())));
		} else {
			notice(strings.getString("notice.medium.result", execactor.name, strings.getString("notice.medium.result.white")));
		}
	/*	if(JinroGame.getProperty("history")[-1].roleIs(new Wolfhead())) {
			notice(strings.getString("notice.medium.result", JinroGame.getProperty("history")[-1].name, JinroGame.getAlias(new Wolfhead().getRoleName())));
		} else if(JinroGame.getProperty("history")[-1].isWolf()) {
			notice(strings.getString("notice.medium.result", JinroGame.getProperty("history")[-1].name, strings.getString("notice.medium.result.black")));
		} else if(JinroGame.getProperty("history")[-1].roleIs(new Minifox())) {
			notice(strings.getString("notice.medium.result", JinroGame.getProperty("history")[-1].name, JinroGame.getAlias(new Minifox().getRoleName())));
		} else {
			notice(strings.getString("notice.medium.result", JinroGame.getProperty("history")[-1].name, strings.getString("notice.medium.result.white")));
		}*/
	}
}
