package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Wickedwoman
// Camp: Civilians

class Wickedwoman extends Civilian {
	def static order = 24;
	def static strings = Civilian.strings.attachBundle("roles/Wickedwoman.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = true;	// All roles must define own "bite" property.	//この役職が初日犠牲者として死亡しないかどうかを表します。
	def static isInvisible() {
		return true;
	}
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	def getPriority() {
		return 43;
	}
	Wickedwoman(actor = null) {
		super(actor);
	}
	def getRoleName() {
		return strings.getString("wickedwoman");
		//wickedwoman=悪女
	}
	// Calls when start argument/night time.
	def startPhase() {
		super.startPhase();
	}
	
	// Returns the actor's command list
	def getCommands(actors) {
		def commands = super.getCommands(actors);
		if(!isLive()) {
			return commands;
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 3:
				if(JinroGame.day == 0) {
					
					if(this.lovers == 0)  {
						if(!target) {
							actors.findAll{ (it.name != name) && (it.isLive()) }.each {
								if( ((it.lovers == 0) && (it.keep == 0)) || JinroGame.getProperty("yagamo") ) {
									commands << strings.getString("command.wicked") + "@" + it.name;
									//command.wicked=本命
								}
							}
						}
						if(!target2) {
							actors.findAll{ (it.name != name) && (it.isLive()) }.each {
								if( ((it.lovers == 0) && (it.keep == 0)) || JinroGame.getProperty("yagamo") ) {
									commands << strings.getString("command.wicked2") + "@" + it.name;
									//command.wicked2=キープ
								}
							}
						}
					}
				}
				break;
		}
		return commands;
	}
	//コマンドを処理します。
	def receiveMessage(type, target) {
		super.receiveMessage(type, target);
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				break;
			case 3:
				if(JinroGame.day == 0) {	//初日
					if(this.target && this.target2) { return; }
					if(type == strings.getString("command.wicked")) {
						//command.wicked=本命
						if(this.target2 == target) { return; }
						if(this.target) { return; }
						if(this.lovers != 0) { return; }			//既に恋人なら受け付けない
						if(target?.name != name && target?.isLive()) {
							if( ((target.lovers == 0) && (target.keep == 0))
								 || JinroGame.getProperty("yagamo") )	//targetがまだ恋人でない
							{
								target.lovers |= this.cupid;
								notice(strings.getString("notice.wicked.target", target.name));
								//notice.wicked.target=本命→%Sさん
								def actors = JinroGame.getActors();
								def sellovers = actors.findAll { ((it.lovers & this.cupid) != 0) };
								if(sellovers.size() >= 1) {
									this.target = target;
									notice(strings.getString("notice.wicked1", sellovers[0].name ));
									//notice.wicked1=あなたが放った愛の矢(本命)は%Sさんに命中しました。
									
								}
							} else {		//targetが既に恋人
								notice(strings.getString("notice.wicked3", target?.name ));
								//notice.wicked3=%Sさんには既に愛の矢が刺さっています。
							}
						}
					}
					if(type == strings.getString("command.wicked2")) {
						//command.wicked2=キープ
						if(this.target == target) { return; }
						if(this.target2) { return; }
						if(target?.name != name && target?.isLive()) {
							if( ((target.lovers == 0) && (target.keep == 0))
								 || JinroGame.getProperty("yagamo") )	//targetがまだ恋人でない
							{
								this.target2 = target;
								target.keep |= this.cupid;
								notice(strings.getString("notice.wicked2.target", target.name));
								//notice.wicked2.target=キープ→%Sさん
								notice(strings.getString("notice.wicked2", target.name ));
								//あなたが放った愛の矢(キープ)は%Sさんに命中しました。
							} else {
								notice(strings.getString("notice.wicked3", target?.name ));
								//notice.wicked3=%Sさんには既に愛の矢が刺さっています。
							}
						}
					}
					if(this.target && this.target2) {
						this.lovers |= this.cupid;
						
						//恋人（本命）にメッセージ
						def mes0 = strings.getString("notice.wickedwoman.partner", this.name );
						//notice.wickedwoman.partner=愛の矢があなたに命中しました。あなたの恋人は%Sさんです。
						if(this.target.skypeid) {
							JinroSkype.notice(this.target.skypeid, mes0);
						}
						noticelog << mes0;
						JinroGame.addLog(strings.getString("notice.log",this.target.name, mes0));
						//notice.log=%1$Sさんへの通知：%2$S
						
						//恋人（キープ）にメッセージ
						if(this.target2.skypeid) {
							JinroSkype.notice(this.target2.skypeid, mes0);
						}
						noticelog << mes0;
						JinroGame.addLog(strings.getString("notice.log", this.target2.name, mes0));
						//notice.log=%1$Sさんへの通知：%2$S
						
						//恋人チャット作成
						def skypeids = [];
						if(this.target.skypeid) {
							skypeids << this.target.skypeid;
						}
						if(this.skypeid) {
							skypeids << this.skypeid;
						}
						if(skypeids.size() >= 2) {
							JinroSkype.notice(skypeids as String[], 
								strings.getString("chat.created", "恋人" ));
							//chat.created=%Sチャットです。チャット捕捉のために何か言葉を打ち込んでください。
						}
						
						def skypeids2 = [];
						if(this.target2.skypeid) {
							skypeids2 << this.target2.skypeid;
						}
						if(this.skypeid) {
							skypeids2 << this.skypeid;
						}
						if(skypeids2.size() >= 2) {
							JinroSkype.notice(skypeids2 as String[], 
								strings.getString("chat.created", "恋人" ));
							//chat.created=%Sチャットです。チャット捕捉のために何か言葉を打ち込んでください。
						}
						
					}
					return;
				}
				break;
		}
	}
	
	// Checks if the game can go to next phase.
	//ゲームを進められるかどうかを返します。必要な能力の使用が済んだかどうかなどで判断します。
	def checkStep() {
	//	if(!super.checkStep()) {
	//		return false;
	//	}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
			case 1:
				if(!super.checkStep()) {
					return false;
				}
				return true;
				break;
			case 3:
				if(JinroGame.day == 0) {
					if(this.lovers != 0) {
						return true;
					}
					if(this.target && this.target2) {
						return true;
					}
					return false;
				}
				return true;
				break;
		}
		return false;
	}
	// Notifies the actor of the role.
	//参加者に対し役職の通知を行います。
	def noticeRole() {
		def name = JinroGame.getAlias(getRoleName());
		notice(strings.getString("notice.role", name));
		//notice.role=あなたは%Sです。
		notice(strings.getString("notice.wicked0"));
		//notice.wicked0=初日の夜に誰か一人と本命の恋人になり、もう1人と仮の恋人になる事ができます。
		notice(strings.getString("notice.wicked"));
		//notice.wicked=「本命＠対象の名前」、「キープ＠対象の名前」の形式で実行し、本命とキープを決定してください。
	}
	// Judges victory or defeat.
	// if the result is... 0: civilians win, 1: wolves win, 2: foxes win
	//勝利結果 0=村 1=狼 2=狐 3=恋人 4=狐＋恋人 return true=勝利 false=敗北
	def judge(result) {
			def lover = JinroGame.getActors().findAll { ((it.lovers & this.lovers) != 0) && it.isLive() };
			def lovercount = [];
			def lovermax = 0;
			lover.each {
				if(lovercount[it.lovers] == null) lovercount[it.lovers] = 1;
				lovercount[it.lovers]++;
				if(lovercount[it.lovers] > lovermax) {
					lovermax = lovercount[it.lovers];
				}
			}
			if(lovermax >= 2) {
				return (result == 3) || (result == 4);	//恋人
			} else {
				return false;
			}
	//	}
		return false;
	}
}
