package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Wolf's fortuneteller
// Camp: Wolves

class Wolffortune extends Wolf {
	def static order = 19;
	def static strings = Wolf.strings.attachBundle("roles/Wolffortune.properties");
	def static number = 0;	// All roles must define own "number" property.
	def static bite = true;	// All roles must define own "bite" property.
	def static isInvisible() {
		return true;
	}
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	def getPriority() {
		return 95;
	}
	Wolffortune(actor = null) {
		super(actor);
	}
	def getRoleName() {
		return strings.getString("wolffortune");
		//wolffortune=狼占い
	}
	// Calls when start argument/night time.
	def startPhase() {
		super.startPhase();
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				break;
			case 1:
				if( (JinroGame.getProperty("zerodaynofortune") == true) && (JinroGame.day == 0) ) {
					notice(strings.getString("notice.nodivine"));
					//notice.nodivine=初日は占えません。二日目より占う事が出来ます。
					break;
				}
				if(JinroGame.getProperty("zerodayrandom") == true) {
					notice(strings.getString("notice.divine6"));
					//notice.divine6=初日ランダム占いです。「占いランダム＠」の形式で夜時間の間に決定してください。
				} else {
					notice(strings.getString("notice.divine"));
					//notice.divine=占い先を「占い＠対象の名前」の形式で夜時間の間に決定してください。
					if(JinroGame.day == 0) {
						notice(strings.getString("notice.divine2"));
						//notice.divine2=初日のみ占い先をランダムで選ぶ事が出来ます。
						notice(strings.getString("notice.divine3"));
						//notice.divine3=占い先をランダムで選ぶ場合は「占いランダム＠」としてください。
					}
				}
				notice(strings.getString("notice.divine4"));
				//notice.divine4=但し、占わない事を選択する事も出来ます。
				def actors = JinroGame.getActors();
				def first = actors.findAll { (it.first == true) };
			//	def GM = "初日犠牲者"
			//	if(first) {
			//		GM = first[0].name;
			//	}
				notice(strings.getString("notice.divine5"));
				//notice.divine5=占わない場合は「占わない＠」として下さい。
				break;
		}
	}
	// Returns the actor's command list
	def getCommands(actors) {
		def commands = super.getCommands(actors);
		if(!isLive()) {
			return commands;
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 1:
				if( (JinroGame.getProperty("zerodaynofortune") == true) && (JinroGame.day == 0) ) {
					return commands;
				}
				if(target) { break; }
				if(this.sealtarget == true)  { break; }
				actors.findAll{ it.name != name && it.isLive() }.each {
					commands << strings.getString("command.divine") + "@" + it.name;
				}
			//	actors.findAll{ (it.name != name) && (it.first == true) }.each {
					commands << strings.getString("command.divine2") + "@";
					//command.divine2=占わない
			//	}
				break;
		}
		return commands;
	}
	def receiveMessage(type, target) {
		super.receiveMessage(type, target);
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				break;
			case 1:
				if( (JinroGame.getProperty("zerodaynofortune") == true) && (JinroGame.day == 0) ) {return;}
				if(this.target) { return; }
				if(this.sealtarget == true)  { return; }
				if(type == strings.getString("command.divine")) {
					
					if( (JinroGame.getProperty("zerodayrandom") == true) && (JinroGame.day == 0) ) {
						//初日のランダム占い有り
						def actors = JinroGame.getActors().findAll { it.isLive() && (it.name != name) };
						if(JinroGame.getProperty("zerodayrandombeginners") == true) {	//初心者モードは村限定
							actors = actors.findAll { it.isCivilian() };
						}
						this.target = actors.get(Math.floor(JinroGame.invokeMethod("rand") * actors.size()) as int);
						notice(strings.getString("notice.divine.target", this.target.name));
						//notice.divine.target=占い先→%Sさん
						divine();
					} else {
						if(target?.name != name && target?.isLive()) {
							this.target = target;
							notice(strings.getString("notice.divine.target", target.name));
							divine();
						}
					}
				}
				if(type == strings.getString("command.divine2")) {
					def name = "";
					if(target != null) {
						name = target?.name;
					}
					//command.divine2=占わない
					this.sealtarget = true;
					notice(strings.getString("notice.divine.target21", name));
					//notice.divine.target2=占わない→%Sさん
					notice(strings.getString("notice.divine.target3"));
					//notice.divine.target3=今宵、あなたは占いを放棄した。
				}
				if(type == strings.getString("command.randomdivine")) {
				//command.randomdivine=占いランダム
					if(JinroGame.day == 0) {
						def actors = JinroGame.getActors().findAll { it.isLive() && (it.name != name) };
						if(JinroGame.getProperty("zerodayrandombeginners") == true) {	//初心者モードは村限定
							actors = actors.findAll { it.isCivilian() };
						}
						this.target = actors.get(Math.floor(JinroGame.invokeMethod("rand") * actors.size()) as int);
						notice(strings.getString("notice.divine.target", this.target.name));
						//notice.divine.target=占い先→%Sさん
						divine();
					}
				}
				break;
		}
	}
	// Checks if the game can go to next phase.
	def checkStep() {
		if(!super.checkStep()) {
			return false;
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time + JinroGame.getProperty("firstdaytime")*2) {
			case 0:
				return true;
			case 1:
				if( (JinroGame.getProperty("zerodaynofortune") == true) && (JinroGame.day == 0) ) {
					return true;
				}
				if(target) { return true; }
				if(this.sealtarget == true)  { return true; }
				break;
		}//*/
		return false;
	}
	def divine() {
		target.divined = true;						//呪殺用
		def role = JinroGame.getAlias( target.getRoleName() );
		if(target.cupid != 0) {
			role =  strings.getString("cupid");
		}
		notice(strings.getString("notice.divine.result", target.name, role));
		if(target.roleIs(new Fortuneteller()) || target.roleIs(new Mindreader()) ) {	//占い師を占った時
			nextstate = State.recursed;
			countdown = 1;
		}
	}
}
